image: registry.gitlab.com/gitlab-org/terraform-images/stable:latest
variables:
  TF_STATE_NAME: monitoting-dns-records
  TF_ROOT: $CI_PROJECT_DIR
  TF_ADDRESS: $CI_API_V4_URL/projects/$CI_PROJECT_ID/terraform/state/$CI_PROJECT_NAME
  EMAIL: $EMAIL
  CLOUDFLARE_ZONE_ID: $CLOUDFLARE_ZONE_ID
  CLOUDFLARE_API_TOKEN: $CLOUDFLARE_API_TOKEN
  MONITORING_IP: $MONITORING_IP
  GRAFANA_IP: $GRAFANA_IP

cache:
  key: test
  paths:
    - $TF_ROOT/dns_settings/.terraform

before_script:
  - cd $TF_ROOT/dns_settings

stages:
  - prepare
  - validate
  - build
  - deploy

init:
  stage: prepare
  script:
    - gitlab-terraform init
validate:
  stage: validate
  script:
    - gitlab-terraform init
    - gitlab-terraform validate
  environment:
    name: test


plan:
  stage: build
  script:
    - >
      gitlab-terraform plan
      -var="monitoring_ip=$MONITORING_IP"
      -var="grafana_ip=$GRAFANA_IP"
      -var="email=$EMAIL"
      -var="cloudflare_zone_id=$CLOUDFLARE_ZONE_ID"
      -var="cloudflare_api_token=$CLOUDFLARE_API_TOKEN"
    - gitlab-terraform plan-json
  artifacts:
    name: plan
    paths:
      - $TF_ROOT/dns_settings/plan.cache
    reports:
      terraform: $TF_ROOT/dns_settings/plan.json
  environment:
    name: test

apply:
  stage: deploy
  environment:
    name: test
  script:
    - gitlab-terraform apply
  dependencies:
    - plan
  when: manual
  only:
    - main

destroy:
  stage: .post
  environment:
    name: test
  script:
    - >
     gitlab-terraform destroy
     -var="monitoring_ip=$MONITORING_IP"
     -var="grafana_ip=$GRAFANA_IP"
     -var="email=$EMAIL"
     -var="cloudflare_zone_id=$CLOUDFLARE_ZONE_ID"
     -var="cloudflare_api_token=$CLOUDFLARE_API_TOKEN"
  when: manual
  only:
    - main